int Config()
{
  FarMenuItem MenuItems[3];
  memset(MenuItems,0,sizeof(MenuItems));
  int Msgs[]={mConfigMenu1,mConfigMenu2,mConfigMenu3};

  for(unsigned int i=0;i<sizeof(MenuItems)/sizeof(MenuItems[0]);++i)
  {
    MenuItems[i].Checked=MenuItems[i].Separator=0;
    sprintf(MenuItems[i].Text, "%s", GetMsg(Msgs[i])); // Text in menu
  };
  int MenuCode=0;
  while(TRUE)
  {
    for(unsigned int i=0;i<sizeof(MenuItems)/sizeof(MenuItems[0]);++i)
      MenuItems[i].Selected=0;
    MenuItems[MenuCode].Selected=TRUE;
    // Show menu
    MenuCode=Info.Menu(Info.ModuleNumber,-1,-1,0,FMENU_AUTOHIGHLIGHT|FMENU_WRAPMODE,
                           NULL,NULL,"Config",NULL,NULL,
                           MenuItems,sizeof(MenuItems)/sizeof(MenuItems[0]));
    if(MenuCode==-1)
      break;
    else if(MenuCode==0)
    {
      //Show dialog
      /*
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      00                                                                            00
      01    Backgroung copy ͻ   01
      02    [ ] Use system copy history                                           02
      03    [ ] Show full info                                                    03
      04     Copy Ŀ    04
      05     ( ) Overwrite all existing files                                   05
      06     ( ) Append to all existing files                                   06
      07     ( ) Skip all existing files                                        07
      08     ( ) Refresh old files                                              08
      09                                                                        09
      10     [ ] Copy access rights                                             10
      11     [ ] Clear R/O attribute on &source                                 11
      12     [ ] Clear R/O attribute on &destination                            12
      13     [ ] Abort on error                                                 13
      14        14
      15     Delete Ŀ    15
      16     [ ] Clear R/O attribute                                            16
      17     [ ] Abort on error                                                 17
      18        18
      19   Ķ   19
      20                    [ Save ]              [ Cancel ]                      20
      21   ͼ   21
      22                                                                            22
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      */
     
      static struct InitDialogItem InitItems[]={
      /* 0*/  {DI_DOUBLEBOX,3,1,72,21,0,0,0,0,(char *)mName},
      /* 1*/  {DI_CHECKBOX,5,2,0,0,0,0,0,0,(char *)mConfigHistory},
      /* 2*/  {DI_CHECKBOX,5,3,0,0,0,0,0,0,(char *)mConfigFullInfo},

      /* 3*/  {DI_SINGLEBOX,5,4,70,14,0,0,DIF_LEFTTEXT,0,(char *)mCpyDlgCopyTitle},
      /* 4*/  {DI_RADIOBUTTON,7,5,0,0,0,0,DIF_GROUP,0,(char *)mCpyDlgOpt1},
      /* 5*/  {DI_RADIOBUTTON,7,6,0,0,0,0,0,0,(char *)mCpyDlgOpt2},
      /* 6*/  {DI_RADIOBUTTON,7,7,0,0,0,0,0,0,(char *)mCpyDlgOpt3},
      /* 7*/  {DI_RADIOBUTTON,7,8,0,0,0,0,0,0,(char *)mCpyDlgOpt4},
      /* 8*/  {DI_CHECKBOX,7,10,0,0,0,0,0,0,(char *)mCpyDlgChkAccess},
      /* 9*/  {DI_CHECKBOX,7,11,0,0,0,0,0,0,(char *)mCpyDlgChk2},
      /*10*/  {DI_CHECKBOX,7,12,0,0,0,0,0,0,(char *)mCpyDlgChk3},
      /*11*/  {DI_CHECKBOX,7,13,0,0,0,0,0,0,(char *)mCpyDlgChk4},

      /*12*/  {DI_SINGLEBOX,5,15,70,18,0,0,DIF_LEFTTEXT,0,(char *)mDelDlgTitle},
      /*13*/  {DI_CHECKBOX,7,16,0,0,0,0,0,0,(char *)mDelDlgChk1},
      /*14*/  {DI_CHECKBOX,7,17,0,0,0,0,0,0,(char *)mConfigDelAbort},

      /*15*/  {DI_TEXT,-1,19,0,0,0,0,DIF_SEPARATOR,0,""},
      /*16*/  {DI_BUTTON,0,20,0,0,0,0,DIF_CENTERGROUP,1,(char *)mConfigSave},
      /*17*/  {DI_BUTTON,0,20,0,0,0,0,DIF_CENTERGROUP,0,(char *)mConfigCancel}
      };

      struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
      InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));
      DialogItems[1].Selected=Opt.CopyHistory;
      DialogItems[2].Selected=Opt.CopyFullInfo;
      DialogItems[4+Opt.CopyType].Selected=1;
      DialogItems[8].Selected=Opt.CopyAccess;
      DialogItems[9].Selected=Opt.CopyROSrc;
      DialogItems[10].Selected=Opt.CopyRODest;
      DialogItems[11].Selected=Opt.CopyAbort;

      DialogItems[13].Selected=Opt.DeleteRO;
      DialogItems[14].Selected=Opt.DeleteAbort;
      
      int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,76,23,"Config1",DialogItems,(sizeof(DialogItems)/sizeof(DialogItems[0])),0,0,Config1DialogProc,0);
      if(DlgCode==16)
      {
        Opt.CopyType=0;
        int i=4;
        while(!DialogItems[i].Selected) {i++; Opt.CopyType++;}
        Opt.CopyHistory=DialogItems[1].Selected;
        Opt.CopyFullInfo=DialogItems[2].Selected;
        Opt.CopyAccess=DialogItems[8].Selected;
        Opt.CopyROSrc=DialogItems[9].Selected;
        Opt.CopyRODest=DialogItems[10].Selected;
        Opt.CopyAbort=DialogItems[11].Selected;

        Opt.DeleteRO=DialogItems[13].Selected;
        Opt.DeleteAbort=DialogItems[14].Selected;

        HKEY hKey;
        DWORD Disposition;
        if((RegCreateKeyEx(HKEY_CURRENT_USER,PluginRootKey,0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition)) == ERROR_SUCCESS)
        {
          RegSetValueEx(hKey,"CopyType",0,REG_DWORD,(LPBYTE)&Opt.CopyType,sizeof(Opt.CopyType));
          RegSetValueEx(hKey,"CopyHistory",0,REG_DWORD,(LPBYTE)&Opt.CopyHistory,sizeof(Opt.CopyHistory));
          RegSetValueEx(hKey,"CopyROSrc",0,REG_DWORD,(LPBYTE)&Opt.CopyROSrc,sizeof(Opt.CopyROSrc));
          RegSetValueEx(hKey,"CopyRODest",0,REG_DWORD,(LPBYTE)&Opt.CopyRODest,sizeof(Opt.CopyRODest));
          RegSetValueEx(hKey,"CopyAbort",0,REG_DWORD,(LPBYTE)&Opt.CopyAbort,sizeof(Opt.CopyAbort));
          RegSetValueEx(hKey,"CopyFullInfo",0,REG_DWORD,(LPBYTE)&Opt.CopyFullInfo,sizeof(Opt.CopyFullInfo));
          RegSetValueEx(hKey,"CopyAccess",0,REG_DWORD,(LPBYTE)&Opt.CopyAccess,sizeof(Opt.CopyAccess));
          RegSetValueEx(hKey,"DeleteRO",0,REG_DWORD,(LPBYTE)&Opt.DeleteRO,sizeof(Opt.DeleteRO));
          RegSetValueEx(hKey,"DeleteAbort",0,REG_DWORD,(LPBYTE)&Opt.DeleteAbort,sizeof(Opt.DeleteAbort));
          RegCloseKey(hKey);
        }
      }
    }
    else if(MenuCode==1)
    {
      //Show dialog
      /*
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      00                                                                            00
      01    Backgroung copy ͻ   01
      02    [ ] &Autostart service                                                02
      03   Ķ   03
      04    [ ] Add to &Plugins menu                                              04
      05    [ ] Add to &Viewer menu                                               05
      06    [ ] Add to &Editor menu                                               06
      07   Ķ   07
      08     Info menu Ŀ    08
      09     [ ] &Display message when job list is empty                        09
      10     [ ] Autoselect &only job                                           10
      11        11
      12   Ķ   12
      13    [ ] E&xpand variables in copy dialog                                  13
      14    [ ] Don't &check passive panel type                                   14
      15   Ķ   15
      16                    [ Save ]              [ Cancel ]                      16
      17   ͼ   17
      18                                                                            18
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      */
      static struct InitDialogItem InitItems[]={
      /* 0*/  {DI_DOUBLEBOX,3,1,72,17,0,0,0,0,(char *)mName},
      /* 1*/  {DI_CHECKBOX,5,2,0,0,0,0,0,0,(char *)mConfigAutostart},
      /* 2*/  {DI_TEXT,-1,3,0,0,0,0,DIF_SEPARATOR,0,""},
      /* 3*/  {DI_CHECKBOX,5,4,0,0,0,0,0,0,(char *)mConfigConfigMenu},
      /* 4*/  {DI_CHECKBOX,5,5,0,0,0,0,0,0,(char *)mConfigViewerMenu},
      /* 5*/  {DI_CHECKBOX,5,6,0,0,0,0,0,0,(char *)mConfigEditorMenu},
      /* 6*/  {DI_TEXT,-1,7,0,0,0,0,DIF_SEPARATOR,0,""},
      /* 7*/  {DI_SINGLEBOX,5,8,70,11,0,0,DIF_LEFTTEXT,0,(char *)mConfigInfo},
      /* 8*/  {DI_CHECKBOX,7,9,0,0,0,0,0,0,(char *)mConfigInfoEmpty},
      /* 9*/  {DI_CHECKBOX,7,10,0,0,0,0,0,0,(char *)mConfigInfoOnly},
      /*10*/  {DI_TEXT,-1,12,0,0,0,0,DIF_SEPARATOR,0,""},
      /*11*/  {DI_CHECKBOX,5,13,0,0,0,0,0,0,(char *)mConfigExpandVars},
      /*12*/  {DI_CHECKBOX,5,14,0,0,0,0,0,0,(char *)mConfigPassive},
      /*13*/  {DI_TEXT,-1,15,0,0,0,0,DIF_SEPARATOR,0,""},
      /*14*/  {DI_BUTTON,0,16,0,0,0,0,DIF_CENTERGROUP,1,(char *)mConfigSave},
      /*15*/  {DI_BUTTON,0,16,0,0,0,0,DIF_CENTERGROUP,0,(char *)mConfigCancel}
      };
      struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
      InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));
      DialogItems[1].Selected=PlgOpt.AutoStart;
      DialogItems[3].Selected=PlgOpt.ShowMenu&SHOW_IN_CONFIG;
      DialogItems[4].Selected=PlgOpt.ShowMenu&SHOW_IN_VIEWER;
      DialogItems[5].Selected=PlgOpt.ShowMenu&SHOW_IN_EDITOR;
      DialogItems[8].Selected=PlgOpt.InfoMenu&INFO_MENU_ALT_0;
      DialogItems[9].Selected=PlgOpt.InfoMenu&INFO_MENU_ALT_1;
      DialogItems[11].Selected=PlgOpt.ExpandVars;
      DialogItems[12].Selected=PlgOpt.CheckPassive;

      int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,76,19,"Config2",DialogItems,(sizeof(DialogItems)/sizeof(DialogItems[0])),0,0,Config2DialogProc,0);
      if(DlgCode==14)
      {
        PlgOpt.AutoStart=DialogItems[1].Selected;
        PlgOpt.ShowMenu=0;
        if(DialogItems[3].Selected)
          PlgOpt.ShowMenu|=SHOW_IN_CONFIG;
        if(DialogItems[4].Selected)
          PlgOpt.ShowMenu|=SHOW_IN_VIEWER;
        if(DialogItems[5].Selected)
          PlgOpt.ShowMenu|=SHOW_IN_EDITOR;
        PlgOpt.InfoMenu=0;
        if(DialogItems[8].Selected)
          PlgOpt.InfoMenu|=INFO_MENU_ALT_0;
        if(DialogItems[9].Selected)
          PlgOpt.InfoMenu|=INFO_MENU_ALT_1;
        PlgOpt.ExpandVars=DialogItems[11].Selected;
        PlgOpt.CheckPassive=DialogItems[12].Selected;
        HKEY hKey;
        DWORD Disposition;
        if((RegCreateKeyEx(HKEY_CURRENT_USER,PluginRootKey,0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition)) == ERROR_SUCCESS)
        {
          RegSetValueEx(hKey,"TechAutoStart",0,REG_DWORD,(LPBYTE)&PlgOpt.AutoStart,sizeof(PlgOpt.AutoStart));
          RegSetValueEx(hKey,"TechShowMenu",0,REG_DWORD,(LPBYTE)&PlgOpt.ShowMenu,sizeof(PlgOpt.ShowMenu));
          RegSetValueEx(hKey,"TechInfoMenu",0,REG_DWORD,(LPBYTE)&PlgOpt.InfoMenu,sizeof(PlgOpt.InfoMenu));
          RegSetValueEx(hKey,"TechExpandVars",0,REG_DWORD,(LPBYTE)&PlgOpt.ExpandVars,sizeof(PlgOpt.ExpandVars));
          RegSetValueEx(hKey,"TechCheckPassive",0,REG_DWORD,(LPBYTE)&PlgOpt.CheckPassive,sizeof(PlgOpt.CheckPassive));
          RegCloseKey(hKey);
        }
      }
    }
    else if(MenuCode==2)
    {
      //Show dialog
      /*
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      00                                                                            00
      01    Backgroung copy ͻ   01
      02    &User name:     02
      03    &Password:      03
      04    &Domain:        04
      05     Logon type Ŀ    05
      06     ( ) &Interactive                                                   06
      07     ( ) &Batch                                                         07
      08     ( ) &Service                                                       08
      09        09
      10   Ķ   10
      11    &Maximum errors per thread:                                         11
      12    &Number of listening threads:                                       12
      13   Ķ   13
      14                    [ Save ]              [ Cancel ]                      14
      15   ͼ   15
      16                                                                            16
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      */
      static struct InitDialogItem InitItems[]={
      /* 0*/  {DI_DOUBLEBOX,3,1,72,15,0,0,0,0,(char *)mName},
      /* 1*/  {DI_TEXT,5,2,0,0,0,0,0,0,(char *)mConfigUsername},
      /* 2*/  {DI_EDIT,0,2,70,0,1,0,0,0,""},
      /* 3*/  {DI_TEXT,5,3,0,0,0,0,0,0,(char *)mConfigPassword},
      /* 4*/  {DI_PSWEDIT,0,3,70,0,1,0,0,0,""},
      /* 5*/  {DI_TEXT,5,4,0,0,0,0,0,0,(char *)mConfigDomain},
      /* 6*/  {DI_EDIT,0,4,70,0,1,0,0,0,""},
      /* 7*/  {DI_SINGLEBOX,5,5,70,9,0,0,DIF_LEFTTEXT,0,(char *)mConfigLogon},
      /* 8*/  {DI_RADIOBUTTON,7,6,0,0,0,0,DIF_GROUP,0,(char *)mConfigLogonInteractive},
      /* 9*/  {DI_RADIOBUTTON,7,7,0,0,0,0,0,0,(char *)mConfigLogonBatch},
      /*10*/  {DI_RADIOBUTTON,7,8,0,0,0,0,0,0,(char *)mConfigLogonService},
      /*11*/  {DI_TEXT,-1,10,0,0,0,0,DIF_SEPARATOR,0,""},
      /*12*/  {DI_TEXT,5,11,0,0,0,0,0,0,(char *)mConfigMaxErrors},
      /*13*/  {DI_FIXEDIT,0,11,0,0,1,(int)"#9",DIF_MASKEDIT,0,"20"},
      /*14*/  {DI_TEXT,5,12,0,0,0,0,0,0,(char *)mConfigThreadCount},
      /*15*/  {DI_FIXEDIT,0,12,0,0,1,(int)"#9",DIF_MASKEDIT,0," 4"},
      /*16*/  {DI_TEXT,-1,13,0,0,0,0,DIF_SEPARATOR,0,""},
      /*17*/  {DI_BUTTON,0,14,0,0,0,0,DIF_CENTERGROUP,1,(char *)mConfigSave},
      /*18*/  {DI_BUTTON,0,14,0,0,0,0,DIF_CENTERGROUP,0,(char *)mConfigCancel}
      };
      struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
      InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));
      unsigned int max;
      max=strlen(DialogItems[1].Data);
      if(max<strlen(DialogItems[3].Data))
        max=strlen(DialogItems[3].Data);
      if(max<strlen(DialogItems[5].Data))
        max=strlen(DialogItems[5].Data);
      DialogItems[2].X1=DialogItems[1].X1+max;
      DialogItems[4].X1=DialogItems[3].X1+max;
      DialogItems[6].X1=DialogItems[5].X1+max;
      max=strlen(DialogItems[12].Data);
      if(max<strlen(DialogItems[14].Data))
        max=strlen(DialogItems[14].Data);
      DialogItems[13].X1=DialogItems[12].X1+max; DialogItems[13].X2=DialogItems[13].X1+1;
      DialogItems[15].X1=DialogItems[14].X1+max; DialogItems[15].X2=DialogItems[15].X1+1;

      HKEY hKey; DWORD Type,DataSize; DWORD Value; DWORD Disposition;
      if((RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\"SVC_NAME"\\Parameters",0,KEY_QUERY_VALUE,&hKey))==ERROR_SUCCESS)
      {
        DataSize=sizeof(Value); Value=20;
        RegQueryValueEx(hKey,"MaxError",0,&Type,(LPBYTE)&Value,&DataSize);
        sprintf(DialogItems[13].Data,"%2ld",Value);
        DataSize=sizeof(Value); Value=4;
        RegQueryValueEx(hKey,"ThreadCount",0,&Type,(LPBYTE)&Value,&DataSize);
        if((Value>16)||(Value<1)) Value=4;
        sprintf(DialogItems[15].Data,"%2ld",Value);

        DataSize=256;
        RegQueryValueEx(hKey,"LogonUser",0,&Type,(LPBYTE)DialogItems[2].Data,&DataSize);
        DataSize=256;
        RegQueryValueEx(hKey,"LogonPassword",0,&Type,(LPBYTE)DialogItems[4].Data,&DataSize);
        DataSize=256;
        RegQueryValueEx(hKey,"LogonDomain",0,&Type,(LPBYTE)DialogItems[6].Data,&DataSize);
        DataSize=sizeof(Value); Value=2;
        RegQueryValueEx(hKey,"LogonType",0,&Type,(LPBYTE)&Value,&DataSize);
        RegCloseKey(hKey);
        switch(Value)
        {
          case LOGON32_LOGON_INTERACTIVE:
            DialogItems[8].Selected=TRUE;
            break;
          case LOGON32_LOGON_BATCH:
            DialogItems[9].Selected=TRUE;
            break;
          case LOGON32_LOGON_SERVICE:
            DialogItems[10].Selected=TRUE;
            break;
        }
      }
      if(!(DialogItems[8].Selected||DialogItems[9].Selected||DialogItems[10].Selected))
        DialogItems[8].Selected=TRUE;
      int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,76,17,"Config3",DialogItems,(sizeof(DialogItems)/sizeof(DialogItems[0])),0,0,Config3DialogProc,0);
      if (DlgCode==17)
      {
        if((RegCreateKeyEx(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\"SVC_NAME"\\Parameters",0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition)) == ERROR_SUCCESS)
        {
          Value=atoi(DialogItems[13].Data); if(Value<0) Value=20;
          RegSetValueEx(hKey,"MaxError",0,REG_DWORD,(LPBYTE)&Value,sizeof(Value));
          Value=atoi(DialogItems[15].Data); if((Value<1)||(Value>16)) Value=4;
          RegSetValueEx(hKey,"ThreadCount",0,REG_DWORD,(LPBYTE)&Value,sizeof(Value));
          RegSetValueEx(hKey,"LogonUser",0,REG_SZ,(LPBYTE)DialogItems[2].Data,strlen(DialogItems[2].Data));
          RegSetValueEx(hKey,"LogonPassword",0,REG_SZ,(LPBYTE)DialogItems[4].Data,strlen(DialogItems[4].Data));
          RegSetValueEx(hKey,"LogonDomain",0,REG_SZ,(LPBYTE)DialogItems[6].Data,strlen(DialogItems[6].Data));
          Value=LOGON32_LOGON_INTERACTIVE;
          if(DialogItems[9].Selected)
            Value=LOGON32_LOGON_BATCH;
          if(DialogItems[10].Selected)
            Value=LOGON32_LOGON_SERVICE;
          RegSetValueEx(hKey,"LogonType",0,REG_DWORD,(LPBYTE)&Value,sizeof(Value));
          RegCloseKey(hKey);
        }
        {
          const char *MsgItems[]={"",GetMsg(mActualize),GetMsg(mOk)};
          Info.Message(Info.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
        }
      }
    }
  }
  return FALSE;
}
